AdManager = Core.class()

function AdManager:init()
	if conf.platform == "android" or conf.platform == "ios" then
		require "ads"
		self.ads = {}
		self.banner = nil
		self.interstitial = nil
		self.bootup = true
		self.bannerLoop = true
		self.interstitialLoop = true
		self.canShowBanner = false
		
		self.ads["admob"] = Ads.new("admob")
		self.ads["chartboost"] = Ads.new("chartboost")
		self.ads["chartboost"]:setKey(conf.chartboostId, conf.chartboostSig)
		if conf.platform == "android" then
			self.ads["alternative"] = Ads.new("amazon")
			self.ads["alternative"]:setKey(conf.amazon)
			--self.ads["alternative"]:enableTesting()
		else
			self.ads["alternative"] = Ads.new("iad")
		end
		
		self.ads["chartboost"]:addEventListener(Event.AD_RECEIVED, function(e)
			if e.type == "interstitial" then
				if self.bootup then
					self.bootup = false
					self.ads["chartboost"]:showAd("interstitial", "bootup")
					print("chartboost", "received bootup")
				else
					self.interstitial = "chartboost"
					print("chartboost", "received interstitial")
				end
			end
		end)
		self.ads["admob"]:addEventListener(Event.AD_RECEIVED, function(e)
			if e.type == "interstitial" then
				self.interstitial = "admob"
				print("admob", "received interstitial")
			else
				self.banner = "admob"
				if self.canShowBanner then
					self:showBanner()
				end
				print("admob", "received banner")
			end
		end)
		self.ads["alternative"]:addEventListener(Event.AD_RECEIVED, function(e)
			if e.type == "interstitial" then
				self.interstitial = "alternative"
				print("alternative", "received interstitial")
			else
				self.banner = "alternative"
				if self.canShowBanner then
					self:showBanner()
				end
				print("alternative", "received banner")
			end
		end)
		
		self.ads["chartboost"]:addEventListener(Event.AD_FAILED, function(e)
			if e.type == "interstitial" then
				if self.bootup then
					self.bootup = false
					print("chartboost", "failed bootup")
				else
					print("chartboost", "failed interstitial", "next admob")
					self.ads["admob"]:loadAd("interstitial", conf.admobInterstitial)
				end
			end
		end)
		self.ads["admob"]:addEventListener(Event.AD_FAILED, function(e)
			if e.type == "interstitial" then
				print("admob", "failed interstitial", "next alternative")
				self.ads["alternative"]:loadAd("interstitial")
			else
				self.banner = nil
				print("admob", "failed banner", "next alternative")
				if self.bannerLoop then
					self.bannerLoop = false
					self.ads["alternative"]:loadAd("auto")
				end
			end
		end)
		self.ads["alternative"]:addEventListener(Event.AD_FAILED, function(e)
			if e.type == "interstitial" then
				print("alternative", "failed interstitial", "next chartboost")
				if self.interstitialLoop then
					self.interstitialLoop = false
					self.ads["chartboost"]:loadAd("interstitial", "lost")
				end
			else
				self.banner = nil
				print("alternative", "failed banner", "next admob")
				self.ads["admob"]:loadAd("auto", conf.admobBanner)
			end
		end)
		print("chartboost", "load bootup")
		self.ads["chartboost"]:loadAd("interstitial", "bootup")
		self.ads["chartboost"]:loadAd("moreapps")
		self.ads["alternative"]:loadAd("auto")
	end
end

function AdManager:showBanner()
	print("show banner", self.banner)
	self.bannerLoop = true
	self.canShowBanner = true
	if self.banner then
		if self.banner == "admob" then
			self.ads["admob"]:showAd("auto", conf.admobBanner)
		else
			self.ads[self.banner]:showAd("auto")
		end
		self.ads[self.banner]:setAlignment("center", "bottom")
	end
end

function AdManager:hideBanner()
	self.canShowBanner = false
	print("hide banner", self.banner)
	if self.banner then
		self.ads[self.banner]:hideAd("auto")
	elseif self.ads then
		self.ads[self.banner]:loadAd("auto")
	end
end

function AdManager:loadInterstitial()
	print("load interstitial")
	self.interstitialLoop = true
	if self.ads then
		self.ads["chartboost"]:loadAd("interstitial", "lost")
	end
end

function AdManager:showInterstitial()
	print("show interstitial")
	if self.interstitial == "chartboost" then
		self.ads["chartboost"]:showAd("interstitial", "lost")
	elseif self.interstitial == "admob" then
		self.ads["admob"]:showAd("interstitial", conf.admobInterstitial)
	elseif self.interstitial then
		self.ads[self.interstitial]:showAd("interstitial")
	end
	self.interstitial = nil
end

function AdManager:showMoreApps()
	print("show more apps")
	if not self.ads then
		application:openUrl(conf.showMoreApps)
	else
		self.ads["chartboost"]:showAd("moreapps")
	end
end